//SpriteBatchで描画されるTexture
texture ScreenTexture;
//SpriteBatchで描画されるTextureのサンプラ
sampler ScreenTexSampler:register(s0) = sampler_state
{
    Texture = <ScreenTexture>;
};

//最終的にPixelShaderから出力するデータを示す構造体
struct PixelShaderOutput
{
    float4 rgbColor:COLOR0;//RendarTargetの0番目に出力
    float4 grayColor:COLOR1;//RendarTargetの1番目に出力
};

PixelShaderOutput PixelShaderFunction(float2 texCoord:TEXCOORD)
{
    float4 color = tex2D(ScreenTexSampler,texCoord);

    //最終的に出力するデータを作成
    PixelShaderOutput result;
    //RGBカラー(0番目の出力)にはそのまま
    result.rgbColor = color;
    //Grayカラー(1番目の出力)には色変換した値を与える
    float gray = (color.r + color.g + color.b)/3;
    result.grayColor = float4(gray,gray,gray,1);
    
    //最終出力を返す
    return result;
}

technique Technique1
{
    pass Pass1
    {
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}
